{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "gzip",
            "doc": "Compress files",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04",
                    "id": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-d"
                    },
                    "id": "#gzip.cwl/d"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#gzip.cwl/file"
                }
            ],
            "stdout": "${\n    if (inputs.d){\n        return inputs.file.nameroot;\n    }else{\n        return inputs.file.basename + '.gz';\n    }\n}\n",
            "baseCommand": [
                "gzip",
                "-c"
            ],
            "id": "#gzip.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.d){\n    return inputs.file.nameroot;\n  }else{\n    return inputs.file.basename + '.gz';\n  }\n}\n"
                    },
                    "id": "#gzip.cwl/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-bam_stat",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 1000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/rseqc:3.0.1--py37h516909a_1",
                    "id": "#rseqc-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "rseqc",
                            "version": [
                                "3.0.1"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/rseqc"
                            ]
                        }
                    ],
                    "id": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-bam_stat.cwl/i"
                },
                {
                    "type": "string",
                    "id": "#rseqc-bam_stat.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-q"
                    },
                    "id": "#rseqc-bam_stat.cwl/q"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-bam_stat.cwl/ramMax"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#rseqc-bam_stat.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    }
                }
            ],
            "stdout": "$(inputs.o)",
            "baseCommand": [
                "bam_stat.py"
            ],
            "id": "#rseqc-bam_stat.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-infer_experiment",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 1000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#rseqc-docker.yml"
                },
                {
                    "$import": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-infer_experiment.cwl/i"
                },
                {
                    "type": "string",
                    "id": "#rseqc-infer_experiment.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-q"
                    },
                    "id": "#rseqc-infer_experiment.cwl/q"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-r"
                    },
                    "id": "#rseqc-infer_experiment.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-infer_experiment.cwl/ramMax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-s"
                    },
                    "id": "#rseqc-infer_experiment.cwl/s"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#rseqc-infer_experiment.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    }
                }
            ],
            "stdout": "$(inputs.o)",
            "baseCommand": [
                "infer_experiment.py"
            ],
            "id": "#rseqc-infer_experiment.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-junction_annotation",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 1000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#rseqc-docker.yml"
                },
                {
                    "$import": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-junction_annotation.cwl/i"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-m"
                    },
                    "id": "#rseqc-junction_annotation.cwl/m"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-o"
                    },
                    "id": "#rseqc-junction_annotation.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-q"
                    },
                    "id": "#rseqc-junction_annotation.cwl/q"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-r"
                    },
                    "id": "#rseqc-junction_annotation.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-junction_annotation.cwl/ramMax"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o).junction.bed"
                    },
                    "id": "#rseqc-junction_annotation.cwl/bed"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.o)*.pdf"
                    },
                    "id": "#rseqc-junction_annotation.cwl/pdf"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o).junction.xls"
                    },
                    "id": "#rseqc-junction_annotation.cwl/xls"
                }
            ],
            "baseCommand": [
                "junction_annotation.py"
            ],
            "id": "#rseqc-junction_annotation.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-junction_saturation",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 1000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#rseqc-docker.yml"
                },
                {
                    "$import": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-junction_saturation.cwl/i"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-l"
                    },
                    "id": "#rseqc-junction_saturation.cwl/l"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-m"
                    },
                    "id": "#rseqc-junction_saturation.cwl/m"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o"
                    },
                    "id": "#rseqc-junction_saturation.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-q"
                    },
                    "id": "#rseqc-junction_saturation.cwl/q"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-r"
                    },
                    "id": "#rseqc-junction_saturation.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-junction_saturation.cwl/ramMax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-s"
                    },
                    "id": "#rseqc-junction_saturation.cwl/s"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-u"
                    },
                    "id": "#rseqc-junction_saturation.cwl/u"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "-v"
                    },
                    "id": "#rseqc-junction_saturation.cwl/v"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o).junctionSaturation_plot.pdf"
                    },
                    "id": "#rseqc-junction_saturation.cwl/output"
                }
            ],
            "baseCommand": [
                "junction_saturation.py"
            ],
            "id": "#rseqc-junction_saturation.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-read_distribution",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 1000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#rseqc-docker.yml"
                },
                {
                    "$import": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-read_distribution.cwl/i"
                },
                {
                    "type": "string",
                    "id": "#rseqc-read_distribution.cwl/o"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-r"
                    },
                    "id": "#rseqc-read_distribution.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-read_distribution.cwl/ramMax"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#rseqc-read_distribution.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    }
                }
            ],
            "stdout": "$(inputs.o)",
            "baseCommand": [
                "read_distribution.py"
            ],
            "id": "#rseqc-read_distribution.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "RSeQC-read_quality",
            "doc": "RSeQC package provides a number of useful modules that can comprehensively evaluate high throughput sequence data especially RNA-seq data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 18000\n}\n",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#rseqc-docker.yml"
                },
                {
                    "$import": "#rseqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rseqc-read_quality.cwl/i"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-o"
                    },
                    "id": "#rseqc-read_quality.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-q"
                    },
                    "id": "#rseqc-read_quality.cwl/q"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-r"
                    },
                    "id": "#rseqc-read_quality.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#rseqc-read_quality.cwl/ramMax"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.o)*.pdf"
                    },
                    "id": "#rseqc-read_quality.cwl/output"
                }
            ],
            "baseCommand": [
                "read_quality.py"
            ],
            "id": "#rseqc-read_quality.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://rseqc.sourceforge.net",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-index",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "listing": [
                        "$(inputs.in_bam)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.10--h9402c20_2",
                    "id": "#samtools-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "samtools",
                            "version": [
                                "1.10"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/samtools"
                            ]
                        }
                    ],
                    "id": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#samtools-index.cwl/in_bam"
                },
                {
                    "type": "string",
                    "id": "#samtools-index.cwl/out_bai"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bai"
                    },
                    "id": "#samtools-index.cwl/out_sam"
                }
            ],
            "baseCommand": [
                "samtools",
                "index",
                "-b"
            ],
            "id": "#samtools-index.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-sort",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#samtools-docker.yml"
                },
                {
                    "$import": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#samtools-sort.cwl/in_bam"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-n",
                        "position": 1
                    },
                    "id": "#samtools-sort.cwl/n"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-o"
                    },
                    "id": "#samtools-sort.cwl/out_bam"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--threads",
                        "position": 1
                    },
                    "id": "#samtools-sort.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out_bam)"
                    },
                    "id": "#samtools-sort.cwl/out_sam"
                }
            ],
            "baseCommand": [
                "samtools",
                "sort"
            ],
            "id": "#samtools-sort.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-stats",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#samtools-docker.yml"
                },
                {
                    "$import": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "id": "#samtools-stats.cwl/in_bam",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#samtools-stats.cwl/stdout",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#samtools-stats.cwl/out_stdout",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.stdout)"
                    }
                }
            ],
            "stdout": "$(inputs.stdout)",
            "baseCommand": [
                "samtools",
                "stats"
            ],
            "id": "#samtools-stats.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "Spliced Transcripts Alignment to a Reference",
            "label": "STAR",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "ramMax": "${\n    return inputs.limitGenomeGenerateRAM ? inputs.limitGenomeGenerateRAM : 32000\n}\n",
                    "class": "ResourceRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/star:2.7.5a--0",
                    "id": "#star-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "star",
                            "version": [
                                "2.7.5a"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/star"
                            ]
                        }
                    ],
                    "id": "#star-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "id": "#star.cwl/alignEndsType",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--alignEndsType"
                    },
                    "doc": "Local\nstring: type of read ends alignment\nLocal           ... standard local alignment with soft-clipping allowed\nEndToEnd        ... force end-to-end read alignment, do not soft-clip\nExtend5pOfRead1 ... fully extend only the 5p of the read1, all other ends: local alignment\n"
                },
                {
                    "id": "#star.cwl/alignSJDBoverhangMin",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--alignSJDBoverhangMin"
                    },
                    "doc": "3\nint>0: minimum overhang (i.e. block size) for annotated (sjdb) spliced alignments\n"
                },
                {
                    "id": "#star.cwl/alignSJoverhangMin",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--alignSJoverhangMin"
                    },
                    "doc": "15\nint>0: minimum overhang (i.e. block size) for spliced alignments\n"
                },
                {
                    "id": "#star.cwl/genomeDir",
                    "type": "Directory",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--genomeDir"
                    }
                },
                {
                    "id": "#star.cwl/limitGenomeGenerateRAM",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--limitGenomeGenerateRAM",
                        "valueFrom": "${\n    return parseInt(self, 10) * 1000000;\n }\n"
                    },
                    "doc": "31000000000\nint>0: maximum available RAM (Megabytes) for genome generation\n"
                },
                {
                    "id": "#star.cwl/limitOutSJcollapsed",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--limitOutSJcollapsed"
                    },
                    "doc": "1000000\nint>0: max number of collapsed junctions\n"
                },
                {
                    "id": "#star.cwl/limitSjdbInsertNsj",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--limitSjdbInsertNsj"
                    },
                    "doc": "1000000\nint>=0: maximum number of junction to be inserted to the genome on the fly at the mapping stage, including those from annotations and those detected in the 1st step of the 2-pass run"
                },
                {
                    "id": "#star.cwl/outFileNamePrefix",
                    "type": "string",
                    "default": "",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--outFileNamePrefix"
                    },
                    "doc": "string: output files name prefix (including full or relative path). Can\nonly be defined on the command line.\n"
                },
                {
                    "id": "#star.cwl/outFilterMatchNminOverLread",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterMatchNminOverLread"
                    },
                    "doc": "0.0\nfloat: outFilterMatchNmin normalized to read length (sum of mates' lengths for paired-end reads)\n"
                },
                {
                    "id": "#star.cwl/outFilterMismatchNmax",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterMismatchNmax"
                    },
                    "doc": "33\nint: alignment will be output only if it has fewer mismatches than this value\n"
                },
                {
                    "id": "#star.cwl/outFilterMismatchNoverLmax",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterMismatchNoverLmax"
                    },
                    "doc": "0.3\nint: alignment will be output only if its ratio of mismatches to *mapped* length is less than this value\n"
                },
                {
                    "id": "#star.cwl/outFilterMultimapNmax",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterMultimapNmax"
                    },
                    "doc": "100\nint: read alignments will be output only if the read maps fewer than this value, otherwise no alignments will be output\n"
                },
                {
                    "id": "#star.cwl/outFilterScoreMinOverLread",
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterScoreMinOverLread"
                    },
                    "doc": "0.3\nfloat: outFilterScoreMin normalized to read length (sum of mates' lengths for paired-end reads)\n"
                },
                {
                    "id": "#star.cwl/outFilterType",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFilterType"
                    },
                    "doc": "Normal\nstring: type of filtering\nNormal  ... standard filtering using only current alignment\nBySJout ... keep only those reads that contain junctions that passed filtering into SJ.out.tab\n"
                },
                {
                    "id": "#star.cwl/outSAMtype",
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outSAMtype",
                        "shellQuote": false
                    }
                },
                {
                    "id": "#star.cwl/outSAMunmapped",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outSAMunmapped"
                    }
                },
                {
                    "id": "#star.cwl/outStd",
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--outStd"
                    }
                },
                {
                    "id": "#star.cwl/readFilesCommand",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--readFilesCommand"
                    }
                },
                {
                    "id": "#star.cwl/reads",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--readFilesIn"
                    },
                    "doc": "string(s): paths to files that contain input read1 (and, if needed,  read2)\n"
                },
                {
                    "id": "#star.cwl/seedSearchStartLmax",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--seedSearchStartLmax"
                    },
                    "doc": "12\nint>0: defines the search start point through the read - the read is split into pieces no longer than this value\n"
                },
                {
                    "id": "#star.cwl/threads",
                    "type": "int",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--runThreadN"
                    }
                },
                {
                    "id": "#star.cwl/twopassMode",
                    "type": "string",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--twopassMode"
                    }
                },
                {
                    "id": "#star.cwl/winAnchorMultimapNmax",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--winAnchorMultimapNmax"
                    },
                    "doc": "50\nint>0: max number of loci anchors are allowed to map to\n"
                },
                {
                    "id": "#star.cwl/quantMode",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--quantMode"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#star.cwl/aligned",
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  var p = inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Aligned.out.bam\";\n}\n"
                    },
                    "secondaryFiles": [
                        "${\n   var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n   return [\n     {\"path\": p+\"Log.final.out\", \"class\":\"File\"},\n     {\"path\": p+\"SJ.out.tab\", \"class\":\"File\"},\n     {\"path\": p+\"Log.out\", \"class\":\"File\"}\n   ];\n}\n"
                    ]
                },
                {
                    "id": "#star.cwl/bamRemDups",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.bamRemoveDuplicatesType != \"UniqueIdentical\")\n    return null;\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Processed.out.bam\";\n}\n"
                    }
                },
                {
                    "id": "#star.cwl/mappingstats",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "loadContents": true,
                        "glob": "${\n  var p = inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Log.final.out\";\n}\n"
                    }
                },
                {
                    "id": "#star.cwl/readspergene",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"ReadsPerGene.out.tab\";\n}\n"
                    }
                },
                {
                    "id": "#star.cwl/transcriptomesam",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  var p=inputs.outFileNamePrefix?inputs.outFileNamePrefix:\"\";\n  return p+\"Aligned.toTranscriptome.out.bam\";\n}\n"
                    }
                }
            ],
            "baseCommand": [
                "STAR"
            ],
            "id": "#star.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "TPMCalculator",
            "doc": "TPMCalculator quantifies mRNA abundance directly from the alignments by parsing BAM files",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMax": "${\n    return inputs.ramMax ? inputs.ramMax : 2000\n}\n",
                    "ramMin": 2000,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/tpmcalculator:0.0.3--h7376a40_1",
                    "id": "#tpmcalculator-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "tpmcalculator",
                            "version": [
                                "0.0.3"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/tpmcalculator"
                            ]
                        }
                    ],
                    "id": "#tpmcalculator-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-a"
                    },
                    "id": "#tpmcalculator.cwl/a"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-b"
                    },
                    "doc": "BAM file\n",
                    "id": "#tpmcalculator.cwl/b"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-c"
                    },
                    "doc": "Smaller size allowed for an intron created for genes. Default: 16. We recommend to use the reads length\n",
                    "id": "#tpmcalculator.cwl/c"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-e"
                    },
                    "id": "#tpmcalculator.cwl/e"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-g"
                    },
                    "doc": "GTF file\n",
                    "id": "#tpmcalculator.cwl/g"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-k"
                    },
                    "doc": "Gene key to use from GTF file. Default: gene_id\n",
                    "id": "#tpmcalculator.cwl/k"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o"
                    },
                    "doc": "Minimum overlap between a reads and a feature. Default: 8.\n",
                    "id": "#tpmcalculator.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-p"
                    },
                    "doc": "Use only properly paired reads. Default: No. Recommended for paired-end reads.\n",
                    "id": "#tpmcalculator.cwl/p"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-q"
                    },
                    "doc": "Minimum MAPQ value to filter out reads. Default: 0. This value depends on the aligner MAPQ value.\n",
                    "id": "#tpmcalculator.cwl/q"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Maximun the RAM in MB",
                    "id": "#tpmcalculator.cwl/ramMax"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-t"
                    },
                    "doc": "Transcript key to use from GTF file. Default: transcript_id\n",
                    "id": "#tpmcalculator.cwl/t"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.b.nameroot)_genes.ent"
                    },
                    "id": "#tpmcalculator.cwl/gene_ent"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.b.nameroot)_genes.out"
                    },
                    "id": "#tpmcalculator.cwl/gene_out"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.b.nameroot)_genes.uni"
                    },
                    "id": "#tpmcalculator.cwl/gene_uni"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.b.nameroot)_transcripts.ent"
                    },
                    "id": "#tpmcalculator.cwl/transcripts_ent"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.b.nameroot)_transcripts.out"
                    },
                    "id": "#tpmcalculator.cwl/transcripts_out"
                }
            ],
            "baseCommand": [
                "TPMCalculator",
                "-e"
            ],
            "id": "#tpmcalculator.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "https://github.com/ncbi/TPMCalculator",
            "http://schema.org/license": "https://spdx.org/licenses/OPL-1.0"
        },
        {
            "class": "Workflow",
            "doc": "This workflow aligns the fastq files using STAR for paired-end samples",
            "label": "STAR-Alignment-PE",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#star-alignment.cwl/genomeDir"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#star-alignment.cwl/ramMaxSTAR"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#star-alignment.cwl/reads"
                },
                {
                    "type": "int",
                    "id": "#star-alignment.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#star-alignment.cwl/bam_index/out_sam",
                    "type": "File",
                    "id": "#star-alignment.cwl/indexed_bam"
                },
                {
                    "outputSource": "#star-alignment.cwl/alignment/mappingstats",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#star-alignment.cwl/mappingstats"
                },
                {
                    "outputSource": "#star-alignment.cwl/alignment/readspergene",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#star-alignment.cwl/readspergene"
                },
                {
                    "outputSource": "#star-alignment.cwl/bam_sort/out_sam",
                    "type": "File",
                    "id": "#star-alignment.cwl/sorted_bam"
                },
                {
                    "outputSource": "#star-alignment.cwl/alignment/mappingstats",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#star-alignment.cwl/star_stats"
                },
                {
                    "outputSource": "#star-alignment.cwl/bam_stats/out_stdout",
                    "type": "File",
                    "id": "#star-alignment.cwl/stats_bam"
                }
            ],
            "steps": [
                {
                    "run": "#star.cwl",
                    "label": "STAR",
                    "in": [
                        {
                            "default": "Local",
                            "id": "#star-alignment.cwl/alignment/alignEndsType"
                        },
                        {
                            "default": 1,
                            "id": "#star-alignment.cwl/alignment/alignSJDBoverhangMin"
                        },
                        {
                            "default": 15,
                            "id": "#star-alignment.cwl/alignment/alignSJoverhangMin"
                        },
                        {
                            "source": "#star-alignment.cwl/genomeDir",
                            "id": "#star-alignment.cwl/alignment/genomeDir"
                        },
                        {
                            "source": "#star-alignment.cwl/ramMaxSTAR",
                            "id": "#star-alignment.cwl/alignment/limitGenomeGenerateRAM"
                        },
                        {
                            "default": 1000000,
                            "id": "#star-alignment.cwl/alignment/limitOutSJcollapsed"
                        },
                        {
                            "default": 1000000,
                            "id": "#star-alignment.cwl/alignment/limitSjdbInsertNsj"
                        },
                        {
                            "valueFrom": "${\n  var nameroot = inputs.reads[0].nameroot;\n  if (nameroot.endsWith(\".fastq\")){\n     nameroot = nameroot.replace(\".fastq\", \"\")\n  }\n  if (nameroot.endsWith(\"_1\") || nameroot.endsWith(\"_2\")){\n     nameroot = nameroot.slice(0, -2);\n  }\n  return nameroot;\n}\n",
                            "id": "#star-alignment.cwl/alignment/outFileNamePrefix"
                        },
                        {
                            "default": 0,
                            "id": "#star-alignment.cwl/alignment/outFilterMatchNminOverLread"
                        },
                        {
                            "default": 33,
                            "id": "#star-alignment.cwl/alignment/outFilterMismatchNmax"
                        },
                        {
                            "default": 0.3,
                            "id": "#star-alignment.cwl/alignment/outFilterMismatchNoverLmax"
                        },
                        {
                            "default": 100,
                            "id": "#star-alignment.cwl/alignment/outFilterMultimapNmax"
                        },
                        {
                            "default": 0.3,
                            "id": "#star-alignment.cwl/alignment/outFilterScoreMinOverLread"
                        },
                        {
                            "default": "BySJout",
                            "id": "#star-alignment.cwl/alignment/outFilterType"
                        },
                        {
                            "default": [
                                "BAM",
                                "Unsorted"
                            ],
                            "id": "#star-alignment.cwl/alignment/outSAMtype"
                        },
                        {
                            "default": "Within",
                            "id": "#star-alignment.cwl/alignment/outSAMunmapped"
                        },
                        {
                            "default": "Log",
                            "id": "#star-alignment.cwl/alignment/outStd"
                        },
                        {
                            "default": "GeneCounts",
                            "id": "#star-alignment.cwl/alignment/quantMode"
                        },
                        {
                            "default": "zcat",
                            "id": "#star-alignment.cwl/alignment/readFilesCommand"
                        },
                        {
                            "source": "#star-alignment.cwl/reads",
                            "id": "#star-alignment.cwl/alignment/reads"
                        },
                        {
                            "default": 12,
                            "id": "#star-alignment.cwl/alignment/seedSearchStartLmax"
                        },
                        {
                            "source": "#star-alignment.cwl/threads",
                            "id": "#star-alignment.cwl/alignment/threads"
                        },
                        {
                            "default": "Basic",
                            "id": "#star-alignment.cwl/alignment/twopassMode"
                        },
                        {
                            "default": 50,
                            "id": "#star-alignment.cwl/alignment/winAnchorMultimapNmax"
                        }
                    ],
                    "out": [
                        "#star-alignment.cwl/alignment/aligned",
                        "#star-alignment.cwl/alignment/bamRemDups",
                        "#star-alignment.cwl/alignment/mappingstats",
                        "#star-alignment.cwl/alignment/readspergene",
                        "#star-alignment.cwl/alignment/transcriptomesam"
                    ],
                    "id": "#star-alignment.cwl/alignment"
                },
                {
                    "run": "#samtools-index.cwl",
                    "label": "Samtools-index",
                    "in": [
                        {
                            "source": "#star-alignment.cwl/bam_sort/out_sam",
                            "id": "#star-alignment.cwl/bam_index/in_bam"
                        },
                        {
                            "valueFrom": "${ return inputs.in_bam.basename + \".bai\";}",
                            "id": "#star-alignment.cwl/bam_index/out_bai"
                        }
                    ],
                    "out": [
                        "#star-alignment.cwl/bam_index/out_sam"
                    ],
                    "id": "#star-alignment.cwl/bam_index"
                },
                {
                    "run": "#samtools-sort.cwl",
                    "label": "Samtools-sort",
                    "in": [
                        {
                            "source": "#star-alignment.cwl/alignment/aligned",
                            "id": "#star-alignment.cwl/bam_sort/in_bam"
                        },
                        {
                            "valueFrom": "${ return inputs.in_bam.nameroot.replace('Aligned.out', '') + \"_sorted.bam\";}",
                            "id": "#star-alignment.cwl/bam_sort/out_bam"
                        },
                        {
                            "source": "#star-alignment.cwl/threads",
                            "id": "#star-alignment.cwl/bam_sort/threads"
                        }
                    ],
                    "out": [
                        "#star-alignment.cwl/bam_sort/out_sam"
                    ],
                    "id": "#star-alignment.cwl/bam_sort"
                },
                {
                    "run": "#samtools-stats.cwl",
                    "label": "Samtools-stats",
                    "in": [
                        {
                            "source": "#star-alignment.cwl/alignment/aligned",
                            "id": "#star-alignment.cwl/bam_stats/in_bam"
                        },
                        {
                            "valueFrom": "${ return inputs.in_bam.nameroot + \".stats\";}",
                            "id": "#star-alignment.cwl/bam_stats/stdout"
                        }
                    ],
                    "out": [
                        "#star-alignment.cwl/bam_stats/out_stdout"
                    ],
                    "id": "#star-alignment.cwl/bam_stats"
                }
            ],
            "id": "#star-alignment.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": "This workflow retrieve SRA fastqc data and execute QC, alignment and quantification from TPMCalculator",
            "label": "rnaseq-alignment-quantification",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/genomeDir"
                },
                {
                    "type": "File",
                    "id": "#main/genome_bed"
                },
                {
                    "type": "File",
                    "id": "#main/genome_gtf"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/p"
                },
                {
                    "type": "int",
                    "id": "#main/q"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/ramMaxRSeQC"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/ramMaxSTAR"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "id": "#main/reads"
                },
                {
                    "type": "int",
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/bam_stat/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/bam_stat_out"
                },
                {
                    "outputSource": "#main/infer_experiment/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/experiment_out"
                },
                {
                    "outputSource": "#main/gzip_gene_ent/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_gene_ent_out"
                },
                {
                    "outputSource": "#main/gzip_gene_out/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_gene_out_out"
                },
                {
                    "outputSource": "#main/gzip_gene_uni/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_gene_uni_out"
                },
                {
                    "outputSource": "#main/gzip_junction_annotation_bed/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_junction_annotation_bed_out"
                },
                {
                    "outputSource": "#main/gzip_junction_annotation_xls/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_junction_annotation_xls_out"
                },
                {
                    "outputSource": "#main/gzip_transcripts_ent/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_transcripts_ent_out"
                },
                {
                    "outputSource": "#main/gzip_transcripts_out/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/gzip_transcripts_out_out"
                },
                {
                    "outputSource": "#main/alignment/indexed_bam",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/indexed_bam"
                },
                {
                    "outputSource": "#main/junction_annotation/pdf",
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "id": "#main/junction_annotation_pdf_out"
                },
                {
                    "outputSource": "#main/junction_saturation/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/junction_saturation_out"
                },
                {
                    "outputSource": "#main/read_distribution/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/read_distribution_out"
                },
                {
                    "outputSource": "#main/read_quality/output",
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "File"
                        }
                    },
                    "id": "#main/read_quality_out"
                },
                {
                    "outputSource": "#main/alignment/readspergene",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/readspergene"
                },
                {
                    "outputSource": "#main/alignment/sorted_bam",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/sorted_bam"
                },
                {
                    "outputSource": "#main/alignment/mappingstats",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/star_stats"
                },
                {
                    "outputSource": "#main/alignment/stats_bam",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/stats_bam"
                }
            ],
            "steps": [
                {
                    "run": "#star-alignment.cwl",
                    "label": "STAR-alingment",
                    "scatter": "#main/alignment/reads",
                    "in": [
                        {
                            "source": "#main/genomeDir",
                            "id": "#main/alignment/genomeDir"
                        },
                        {
                            "source": "#main/ramMaxSTAR",
                            "id": "#main/alignment/ramMaxSTAR"
                        },
                        {
                            "source": "#main/reads",
                            "id": "#main/alignment/reads"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/alignment/threads"
                        }
                    ],
                    "out": [
                        "#main/alignment/indexed_bam",
                        "#main/alignment/sorted_bam",
                        "#main/alignment/star_stats",
                        "#main/alignment/stats_bam",
                        "#main/alignment/readspergene",
                        "#main/alignment/mappingstats"
                    ],
                    "id": "#main/alignment"
                },
                {
                    "scatter": "#main/bam_stat/i",
                    "run": "#rseqc-bam_stat.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/bam_stat/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc.bam_stat.txt\";}",
                            "id": "#main/bam_stat/o"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/bam_stat/q"
                        }
                    ],
                    "out": [
                        "#main/bam_stat/output"
                    ],
                    "doc": "BAM stats\n",
                    "id": "#main/bam_stat"
                },
                {
                    "scatter": "#main/gzip_gene_ent/file",
                    "in": [
                        {
                            "source": "#main/quantification/gene_ent",
                            "id": "#main/gzip_gene_ent/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_gene_ent/output"
                    ],
                    "run": "#gzip.cwl",
                    "id": "#main/gzip_gene_ent"
                },
                {
                    "scatter": "#main/gzip_gene_out/file",
                    "in": [
                        {
                            "source": "#main/quantification/gene_out",
                            "id": "#main/gzip_gene_out/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_gene_out/output"
                    ],
                    "run": "#gzip.cwl",
                    "id": "#main/gzip_gene_out"
                },
                {
                    "scatter": "#main/gzip_gene_uni/file",
                    "in": [
                        {
                            "source": "#main/quantification/gene_uni",
                            "id": "#main/gzip_gene_uni/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_gene_uni/output"
                    ],
                    "run": "#gzip.cwl",
                    "id": "#main/gzip_gene_uni"
                },
                {
                    "scatter": "#main/gzip_junction_annotation_bed/file",
                    "run": "#gzip.cwl",
                    "in": [
                        {
                            "source": "#main/junction_annotation/bed",
                            "id": "#main/gzip_junction_annotation_bed/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_junction_annotation_bed/output"
                    ],
                    "doc": "Gzip Bed file\n",
                    "id": "#main/gzip_junction_annotation_bed"
                },
                {
                    "scatter": "#main/gzip_junction_annotation_xls/file",
                    "run": "#gzip.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/gzip_junction_annotation_xls/c"
                        },
                        {
                            "source": "#main/junction_annotation/xls",
                            "id": "#main/gzip_junction_annotation_xls/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.basename + \".gz\";}",
                            "id": "#main/gzip_junction_annotation_xls/outFileName"
                        }
                    ],
                    "out": [
                        "#main/gzip_junction_annotation_xls/output"
                    ],
                    "doc": "Gzip XLS file\n",
                    "id": "#main/gzip_junction_annotation_xls"
                },
                {
                    "scatter": "#main/gzip_transcripts_ent/file",
                    "in": [
                        {
                            "source": "#main/quantification/transcripts_ent",
                            "id": "#main/gzip_transcripts_ent/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_transcripts_ent/output"
                    ],
                    "run": "#gzip.cwl",
                    "id": "#main/gzip_transcripts_ent"
                },
                {
                    "scatter": "#main/gzip_transcripts_out/file",
                    "in": [
                        {
                            "source": "#main/quantification/transcripts_out",
                            "id": "#main/gzip_transcripts_out/file"
                        }
                    ],
                    "out": [
                        "#main/gzip_transcripts_out/output"
                    ],
                    "run": "#gzip.cwl",
                    "id": "#main/gzip_transcripts_out"
                },
                {
                    "scatter": "#main/infer_experiment/i",
                    "run": "#rseqc-infer_experiment.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/infer_experiment/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc.infer_experiment.txt\";}",
                            "id": "#main/infer_experiment/o"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/infer_experiment/q"
                        },
                        {
                            "source": "#main/genome_bed",
                            "id": "#main/infer_experiment/r"
                        }
                    ],
                    "out": [
                        "#main/infer_experiment/output"
                    ],
                    "doc": "Infering Experiment\n",
                    "id": "#main/infer_experiment"
                },
                {
                    "scatter": "#main/junction_annotation/i",
                    "run": "#rseqc-junction_annotation.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/junction_annotation/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc\";}",
                            "id": "#main/junction_annotation/o"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/junction_annotation/q"
                        },
                        {
                            "source": "#main/genome_bed",
                            "id": "#main/junction_annotation/r"
                        }
                    ],
                    "out": [
                        "#main/junction_annotation/bed",
                        "#main/junction_annotation/xls",
                        "#main/junction_annotation/pdf"
                    ],
                    "doc": "Junction annotation\n",
                    "id": "#main/junction_annotation"
                },
                {
                    "scatter": "#main/junction_saturation/i",
                    "run": "#rseqc-junction_saturation.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/junction_saturation/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc\";}",
                            "id": "#main/junction_saturation/o"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/junction_saturation/q"
                        },
                        {
                            "source": "#main/genome_bed",
                            "id": "#main/junction_saturation/r"
                        }
                    ],
                    "out": [
                        "#main/junction_saturation/output"
                    ],
                    "doc": "Junction saturation\n",
                    "id": "#main/junction_saturation"
                },
                {
                    "run": "#tpmcalculator.cwl",
                    "label": "tpmcalculator",
                    "scatter": "#main/quantification/b",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/quantification/a"
                        },
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/quantification/b"
                        },
                        {
                            "default": true,
                            "id": "#main/quantification/e"
                        },
                        {
                            "source": "#main/genome_gtf",
                            "id": "#main/quantification/g"
                        },
                        {
                            "source": "#main/p",
                            "id": "#main/quantification/p"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/quantification/q"
                        }
                    ],
                    "out": [
                        "#main/quantification/gene_ent",
                        "#main/quantification/gene_out",
                        "#main/quantification/gene_uni",
                        "#main/quantification/transcripts_ent",
                        "#main/quantification/transcripts_out"
                    ],
                    "id": "#main/quantification"
                },
                {
                    "scatter": "#main/read_distribution/i",
                    "run": "#rseqc-read_distribution.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/read_distribution/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc.read_distribution.txt\";}",
                            "id": "#main/read_distribution/o"
                        },
                        {
                            "source": "#main/genome_bed",
                            "id": "#main/read_distribution/r"
                        }
                    ],
                    "out": [
                        "#main/read_distribution/output"
                    ],
                    "doc": "Read distribution\n",
                    "id": "#main/read_distribution"
                },
                {
                    "scatter": "#main/read_quality/i",
                    "run": "#rseqc-read_quality.cwl",
                    "in": [
                        {
                            "source": "#main/alignment/sorted_bam",
                            "id": "#main/read_quality/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot.replace('.bam', '') + \"_rseqc\";}",
                            "id": "#main/read_quality/o"
                        },
                        {
                            "source": "#main/q",
                            "id": "#main/read_quality/q"
                        }
                    ],
                    "out": [
                        "#main/read_quality/output"
                    ],
                    "doc": "Read quality\n",
                    "id": "#main/read_quality"
                }
            ],
            "id": "#main",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf",
        "https://schema.org/version/latest/schema.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
